Public Class FEM3Dat5
    '矩形分布荷重の座標位置荷重への変換設定ﾌﾟﾛｸﾞﾗﾑ

    Dim Fx$         'ﾌｧｲﾙ名

    Dim Nfp As Integer          '荷重点数

    Dim XL, YL As Single        'XY矩形の辺長さ

    Dim Mesh(2) As Integer      '1辺のメッシュ数

    Dim Cx(3), Cy(3) As Single  'XY座標の全体座標に対する方向余弦
    Dim Fpoint(3) As Single     '座標位置の荷重
    Dim Fsum(3) As Single       '合計荷重

    Dim XPL(), YPL() As Single          '荷重点の平面座標
    Dim Xfp(), Yfp(), Zfp() As Single   '荷重点の全体座標
    Dim Xvert(4), YVert(4), ZVert(4) As Single   '4頂点の座標

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定

        Nfp = Mesh(1) * Mesh(2)
        ReDim XPL(Nfp), YPL(Nfp)
        ReDim Xfp(Nfp), Yfp(Nfp), Zfp(Nfp)

    End Sub

    Private Sub Debug1()
        'XY座標値を出力して停止
        Dim aa$, fxx$
        Dim i As Integer

        fxx$ = DirOpen$ + "\FEM3Dat5debug1.dat"
        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "XY座標値（No.、X、Y）"
        sw.WriteLine(aa$)
        For i = 1 To Nfp
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(XPL(i))
            aa$ = aa$ + ",  " + Str$(YPL(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        Stop
    End Sub

    Private Sub Debug2()
        '全体座標値を出力して停止
        Dim aa$, fxx$
        Dim i As Integer

        fxx$ = DirOpen$ + "\FEM3Dat5debug2.dat"
        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "全体座標値（No.、X、Y、Z）"
        sw.WriteLine(aa$)
        For i = 1 To Nfp
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(Xfp(i))
            aa$ = aa$ + ",  " + Str$(Yfp(i))
            aa$ = aa$ + ",  " + Str$(Zfp(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        Stop
    End Sub

    Private Sub FADatSet2()
        '座標位置荷重ﾃﾞｰﾀの追加
        Dim i, id, nfb As Integer

        nfb = NforceA
        Dim xbuf(nfb), ybuf(nfb), zbuf(nfb) As Single
        Dim fbuf(nfb, Ndim) As Single
        For i = 1 To NforceA
            xbuf(i) = XFA(i)
            ybuf(i) = YFA(i)
            zbuf(i) = ZFA(i)
            For id = 1 To Ndim
                fbuf(i, id) = ForceA(i, id)
            Next id
        Next i

        NforceA = nfb + Nfp
        ReDim XFA(NforceA), YFA(NforceA), ZFA(NforceA), ForceA(NforceA, Ndim)
        For i = 1 To nfb
            XFA(i) = xbuf(i)
            YFA(i) = ybuf(i)
            ZFA(i) = zbuf(i)
            For id = 1 To Ndim
                ForceA(i, id) = fbuf(i, id)
            Next id
        Next i
        For i = 1 To Nfp
            nfb = nfb + 1
            XFA(nfb) = Xfp(i)
            YFA(nfb) = Yfp(i)
            ZFA(nfb) = Zfp(i)
            For id = 1 To Ndim
                ForceA(nfb, id) = Fpoint(id)
            Next id
        Next i

    End Sub

    Private Sub ForceCalc()
        '荷重の計算
        Dim i As Integer

        For i = 1 To 3
            Fpoint(i) = Fsum(i) / Nfp
        Next i

    End Sub

    Private Sub MeshGene()
        'メッシュ生成
        Xvert(4) = Xvert(1) + (Xvert(3) - Xvert(2))
        YVert(4) = YVert(1) + (YVert(3) - YVert(2))
        ZVert(4) = ZVert(1) + (ZVert(3) - ZVert(2))

        Call XYPlane()  'XY平面に変換

        Call DataSize() 'ﾃﾞｰﾀｻｲｽﾞの設定

        Call XYPosCalc()    'XY平面の座標値計算
        'Call Debug1()

        Call PosTrans() '座標変換
        'Call Debug2()

        Call ForceCalc()    '荷重の計算

    End Sub

    Private Sub PlaneCheck(ByRef kh As Integer)
        '外郭面のチェック
        Dim aa$
        Dim i, ke As Integer
        Dim s, t, u, xb, yb, zb As Single
        ReDim KdrawElem(Nelem)

        kh = 0
        For i = 1 To Nelem
            KdrawElem(i) = 1
        Next i
        Call AxisCheck(1, Nelem, Rlenmax, AxisMax, AxisMin, Xdata, Ydata, Zdata)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        EpsL = Rlenmax * 0.00001

        CInc = 3
        CRed = 0.2
        For i = 1 To Nfp
            xb = Xfp(i)
            yb = Yfp(i)
            zb = Zfp(i)
            Call ElemFA(ke, s, t, u, xb, yb, zb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

    End Sub

    Private Sub PosTrans()
        '座標変換
        Dim i As Integer
        Dim xb, yb, zb As Single
        For i = 1 To Nfp
            xb = XPL(i) * Cx(1) + YPL(i) * Cy(1)
            yb = XPL(i) * Cx(2) + YPL(i) * Cy(2)
            zb = XPL(i) * Cx(3) + YPL(i) * Cy(3)
            Xfp(i) = xb + Xvert(1)
            Yfp(i) = yb + YVert(1)
            Zfp(i) = zb + ZVert(1)
        Next i

    End Sub

    Private Sub SpecSet(ByRef kh As Integer)
        '仕様セット
        Dim aa$
        Dim i As Integer

        Xvert(1) = Val(TextBox1.Text)
        YVert(1) = Val(TextBox2.Text)
        ZVert(1) = Val(TextBox3.Text)
        Xvert(2) = Val(TextBox4.Text)
        YVert(2) = Val(TextBox5.Text)
        ZVert(2) = Val(TextBox6.Text)
        Xvert(3) = Val(TextBox7.Text)
        YVert(3) = Val(TextBox8.Text)
        ZVert(3) = Val(TextBox9.Text)

        Mesh(1) = Val(TextBox15.Text)
        Mesh(2) = Val(TextBox16.Text)

        Fsum(1) = Val(TextBox12.Text)
        Fsum(2) = Val(TextBox13.Text)
        Fsum(3) = Val(TextBox14.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        For i = 1 To 2
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

    End Sub

    Private Sub XYPlane()
        'XY平面に変換
        Dim b1, b2, b3 As Single
        b1 = Xvert(2) - Xvert(1)
        b2 = YVert(2) - YVert(1)
        b3 = ZVert(2) - ZVert(1)
        XL = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        Cx(1) = b1 / XL
        Cx(2) = b2 / XL
        Cx(3) = b3 / XL
        b1 = Xvert(4) - Xvert(1)
        b2 = YVert(4) - YVert(1)
        b3 = ZVert(4) - ZVert(1)
        YL = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        Cy(1) = b1 / YL
        Cy(2) = b2 / YL
        Cy(3) = b3 / YL

    End Sub

    Private Sub XYPosCalc()    'XY平面の座標値計算
        Dim i, j, n As Integer
        Dim deltax, deltay, xb, yb As Single

        deltax = XL / Mesh(1)
        deltay = YL / Mesh(2)
        n = 0
        xb = -0.5 * deltax
        For i = 1 To Mesh(1)
            xb = xb + deltax
            yb = -0.5 * deltay
            For j = 1 To Mesh(2)
                yb = yb + deltay
                n = n + 1
                XPL(n) = xb
                YPL(n) = yb
            Next j
        Next i

    End Sub

    Private Sub FEM3Dat5_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim i As Integer

        Fx$ = DirOpen$ + "\FEM3Dat5.tmp"
        Try
            Dim sr As New IO.StreamReader(Fx$)
            For i = 1 To 3
                Xvert(i) = sr.ReadLine
                YVert(i) = sr.ReadLine
                ZVert(i) = sr.ReadLine
            Next i
            Mesh(1) = sr.ReadLine
            Mesh(2) = sr.ReadLine
            For i = 1 To 3
                Fsum(i) = sr.ReadLine
            Next i
            sr.Close()
        Catch
            '処理不要
        End Try

        If Mesh(1) = 0 Then
            Mesh(1) = 10 : Mesh(2) = 10
        End If
        TextBox1.Text = Str(Xvert(1))
        TextBox2.Text = Str(YVert(1))
        TextBox3.Text = Str(ZVert(1))
        TextBox4.Text = Str(Xvert(2))
        TextBox5.Text = Str(YVert(2))
        TextBox6.Text = Str(ZVert(2))
        TextBox7.Text = Str(Xvert(3))
        TextBox8.Text = Str(YVert(3))
        TextBox9.Text = Str(ZVert(3))
        TextBox15.Text = Str(Mesh(1))
        TextBox16.Text = Str(Mesh(2))
        TextBox12.Text = Str(Fsum(1))
        TextBox13.Text = Str(Fsum(2))
        TextBox14.Text = Str(Fsum(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ix, kh As Integer

        Call SpecSet(kh)  '仕様セット
        If kh < 0 Then
            Exit Sub
        End If

        Dim sw As New IO.StreamWriter(Fx$)
        For i = 1 To 3
            sw.WriteLine(Xvert(i))
            sw.WriteLine(YVert(i))
            sw.WriteLine(ZVert(i))
        Next i
        sw.WriteLine(Mesh(1))
        sw.WriteLine(Mesh(2))
        For i = 1 To 3
            sw.WriteLine(Fsum(i))
        Next i
        sw.Close()

        Call MeshGene()     'メッシュ生成

        Call PlaneCheck(kh)   '外郭面のチェック
        If kh < 0 Then
            aa$ = "外郭面にない座標値点が設定されました！"
            MsgBox(aa$, "座標エラー")
            Exit Sub
        End If

        aa$ = "新しい座標値荷重を入力データに追加しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            Call FADatSet2()    '座標位置荷重ﾃﾞｰﾀの追加
            aa$ = "新しい座標値荷重を入力データに追加しました。"
            aa$ = aa$ + Cr$ + "入力データファイルへの保存が必要です!"
            MsgBox(aa$, 0, "矩形分布荷重の換算処理終了")
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class